Test/PSModule/PSModule.Get.Tests.ps1

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
160
161
162
163
164
165
166
167
168
169
170
171
172
173
174
175
176
177
178
179
180
181
182
183
184
185
186
#
# Copyright (c) Microsoft Corporation.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
# THE SOFTWARE.
#
$CurrentDirectory = Split-Path -Parent $MyInvocation.MyCommand.Path

.  "$CurrentDirectory\..\OneGetTestHelper.ps1"

#
# Pre-Requisite: MyTestModule 1.1, 1.1.2, 3.2.1 are available under the $LocalRepositoryPath for testing purpose only.
# It's been taken care of by SetupPSModuleTest
#

# Calling the setup function
SetupPSModuleTest

Describe -Name  "PSModule Get-TargetResource Basic Tests" -Tags "BVT" {

    BeforeEach {

        # Remove all left over files if exists
        Remove-Item "$($InstallationFolder)\..\..\MyTestModule" -Recurse -Force  -ErrorAction SilentlyContinue      
        Remove-Item "$($InstallationFolder)\..\MyTestModule" -Recurse -Force  -ErrorAction SilentlyContinue      
    }

    AfterEach {

    }     


    # Register a local module repository to make the test run faster. This gets called once per Describe.
    RegisterRepository -Name "LocalRepository" -InstallationPolicy Trusted -Ensure Present

    It "Get-TargetResource with the Mandatory Parameters: Check Present" {            
            
            # Calling Set-TargetResource to install the MyTestModule
            Set-TargetResource -name "MyTestModule" -Repository $LocalRepository -RequiredVersion "3.2.1" -Ensure "Present" -Verbose

            # Calling Get-TargetResource in the PSModule resource
            $result = MSFT_PSModule\Get-TargetResource -Name "MyTestModule" -Repository $LocalRepository 

            # Validate the result
            $result.Ensure | should be "Present"
        }

    It -Skip "Get-TargetResource given the different versions of modules on the same repository: Check Present" {            
           
            #Calling Set-TargetResource to install the module
            Set-TargetResource -name "MyTestModule" -Repository $LocalRepository -RequiredVersion "3.2.1" -Ensure "Present" -Verbose
            Set-TargetResource -name "MyTestModule" -Repository $LocalRepository -RequiredVersion "1.1.2" -Ensure "Present" -Verbose
            Set-TargetResource -name "MyTestModule" -Repository $LocalRepository -RequiredVersion "1.1" -Ensure "Present" -Verbose

            $result = MSFT_PSModule\Get-TargetResource -Name "MyTestModule" -Repository $LocalRepository 

            #Validate the returned results. You can also use "Get-Module -ListAvailable -name MyTestModule" to find these info
            $result.Ensure | should be "Present"
            $result.Name | should be "MyTestModule"
            $result.Repository | should be $LocalRepository
            $result.InstalledVersion | should be "3.2.1"
            $result.InstallationPolicy | should be "Trusted"
            ($result.Author.Length -ne 0)  | should be $true 
            $result.ModuleType | should be "Manifest"
            $result.ModuleBase.StartsWith($InstallationFolder ) | should be $true         
            ($result.Description.Length -ne 0)  | should be $true  
        }

    It "Get-TargetResource with RequiredVersion: Check Present" {
            
            Set-TargetResource -name "MyTestModule" -Repository $LocalRepository -RequiredVersion "1.1.2" -Ensure "Present" -Verbose

            # Provide a req version that exists, expect ensure=Present
            $result = MSFT_PSModule\Get-TargetResource -Name "MyTestModule" -Repository $LocalRepository -RequiredVersion "1.1.2"

            #Validate the returned results
            $result.Ensure | should be "Present"
            $result.Name | should be "MyTestModule"
            $result.InstalledVersion | should be "1.1.2"    
        }

    It "Get-TargetResource with Non-exist RequiredVersion: Check Absent" {
            
            Set-TargetResource -name "MyTestModule" -Repository $LocalRepository  -RequiredVersion "1.1.2" -Ensure "Present" -Verbose

            #Provide a req version does not exist, expect Ensure=Absent
            $result = MSFT_PSModule\Get-TargetResource -Name "MyTestModule" -Repository $LocalRepository -RequiredVersion "10.11.12"

            #Validate the returned results
            $result.Ensure | should be "Absent"  
        }

    It -Skip "Get-TargetResource with MaximumVersion: Check Present" {
            
            Set-TargetResource -name "MyTestModule" -Repository $LocalRepository -RequiredVersion "3.2.1" -Ensure "Present" -Verbose
            Set-TargetResource -name "MyTestModule" -Repository $LocalRepository -RequiredVersion "1.1" -Ensure "Present" -Verbose
            Set-TargetResource -name "MyTestModule" -Repository $LocalRepository -RequiredVersion "1.1.2" -Ensure "Present" -Verbose

            $result = MSFT_PSModule\Get-TargetResource -Name "MyTestModule" -Repository $LocalRepository  -MaximumVersion "2.0"
                
            $result.Ensure | should be "Present"         
            $result.InstalledVersion | should be "1.1.2"  #1.1.2 is the only module -le maximumversion
        }

    It -Skip "Get-TargetResource MinimumVersion: Check Present" {
            
            Set-TargetResource -name "MyTestModule" -Repository $LocalRepository -RequiredVersion "1.1.2" -Ensure "Present" -Verbose
            Set-TargetResource -name "MyTestModule" -Repository $LocalRepository -RequiredVersion "1.1"   -Ensure "Present" -Verbose
            Set-TargetResource -name "MyTestModule" -Repository $LocalRepository -RequiredVersion "3.2.1" -Ensure "Present" -Verbose

            $result = MSFT_PSModule\Get-TargetResource -Name "MyTestModule" -Repository $LocalRepository  -MinimumVersion "1.1.1"

            $result.Ensure | should be "Present"
            $result.InstalledVersion | should be "3.2.1"  #Here two modules: 1.1.1 and 3.2.1 are qualified. Get-Target will return the latest
        }

    It -Skip "Get-TargetResource MinimumVersion and MaximumVersion: Check Present" {
            
            Set-TargetResource -name "MyTestModule" -Repository $LocalRepository -RequiredVersion "1.1.2" -Ensure "Present" -Verbose
            Set-TargetResource -name "MyTestModule" -Repository $LocalRepository -RequiredVersion "1.1" -Ensure "Present" -Verbose
            Set-TargetResource -name "MyTestModule" -Repository $LocalRepository -RequiredVersion "3.2.1" -Ensure "Present" -Verbose

            $result = MSFT_PSModule\Get-TargetResource -Name "MyTestModule" -Repository $LocalRepository  -MinimumVersion "1.0"  -MaximumVersion "2.0"

            $result.Ensure | should be "Present"
            $result.InstalledVersion | should be "1.1.2"  
        }
        
}#Describe

Describe -Name "PSModule Get-TargetResource Error Cases" -Tags "RI" {

    BeforeEach {

        #Remove all left over files if exists
        Remove-Item "$($InstallationFolder)\..\..\MyTestModule" -Recurse -Force  -ErrorAction SilentlyContinue      
        Remove-Item "$($InstallationFolder)\..\MyTestModule" -Recurse -Force  -ErrorAction SilentlyContinue      
    }

    AfterEach {

    }

    #Register a local module repository to make the test run faster. This gets called once per Describe.
    RegisterRepository -Name "LocalRepository" -InstallationPolicy Trusted -Ensure Present

    # Not allow Max, Req and Min co-existance
    It "Get-TargetResource with Max, Req and Min Verion: Check Absent" {
      
        Set-TargetResource -name "MyTestModule" -Repository $LocalRepository -RequiredVersion "1.1.2" -Ensure "Present" -Verbose

        $result = MSFT_PSModule\Get-TargetResource -Name "MyTestModule" -Repository $LocalRepository  `
                                        -MinimumVersion "1.0" -RequiredVersion "1.1.1" #-MaximumVersion "2.3.5"
       
        # Get-Target does not throw, so check 'Absent' is enough here
        $result.Ensure | should be "Absent"
    }
    
    # Min should le Max
    It "Get-TargetResource with Max le Min Verion: Check Absent" {

      
            Set-TargetResource -name "MyTestModule" -Repository $LocalRepository -RequiredVersion "1.1.2" -Ensure "Present" -Verbose
            
            $result = MSFT_PSModule\Get-TargetResource -Name "MyTestModule" -Repository $LocalRepository  `
                                         -MinimumVersion "5.0" #-MaximumVersion "2.5"

           $result.Ensure | should be "Absent"                
    }

    It "Get-TargetResource with NoneExistRepository: Check Absent" {

        Set-TargetResource -name "MyTestModule" -Repository $LocalRepository -RequiredVersion "1.1.2" -Ensure "Present" -Verbose
            
        $result = MSFT_PSModule\Get-TargetResource -Name "MyTestModule" -Repository "NoneExistRepository"  `
                                        -MinimumVersion "1.0" # -MaximumVersion "2.5"

        $result.Ensure | should be "Absent"
    }
}